<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
       <el-form-item label="订单 Id" prop="orderId">
        <el-input v-model="formData.orderId" placeholder="请输入订单 Id" />
      </el-form-item>
      <el-form-item label="金额" prop="amount">
        <el-input v-model="formData.amount" placeholder="请输入金额" />
      </el-form-item>
      <el-form-item label="变动类型" prop="type">
        <el-select v-model="formData.type" placeholder="请选择变动类型">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
      <el-form-item label="变动前余额" prop="beforeBalance">
        <el-input v-model="formData.beforeBalance" placeholder="请输入变动前余额" />
      </el-form-item>
      <el-form-item label="变动后余额" prop="afterBalance">
        <el-input v-model="formData.afterBalance" placeholder="请输入变动后余额" />
      </el-form-item>
      <el-form-item label="描述" prop="description">
        <Editor v-model="formData.description" height="150px" />
      </el-form-item>
      <el-form-item label="创建时间" prop="createdAt">
        <el-date-picker
          v-model="formData.createdAt"
          type="date"
          value-format="x"
          placeholder="选择创建时间"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { UserWalletApi, WalletTransaction } from '@/api/keyboard/userwallet'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  userId: undefined,
  orderId: undefined,
  amount: undefined,
  type: undefined,
  beforeBalance: undefined,
  afterBalance: undefined,
  description: undefined,
  createdAt: undefined
})
const formRules = reactive({
  amount: [{ required: true, message: '金额不能为空', trigger: 'blur' }],
  type: [{ required: true, message: '变动类型不能为空', trigger: 'change' }],
  beforeBalance: [{ required: true, message: '变动前余额不能为空', trigger: 'blur' }],
  afterBalance: [{ required: true, message: '变动后余额不能为空', trigger: 'blur' }],
  createdAt: [{ required: true, message: '创建时间不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number, userId?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  formData.value.userId = userId  as any
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await UserWalletApi.getWalletTransaction(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as WalletTransaction
    if (formType.value === 'create') {
      await UserWalletApi.createWalletTransaction(data)
      message.success(t('common.createSuccess'))
    } else {
      await UserWalletApi.updateWalletTransaction(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    userId: undefined,
    orderId: undefined,
    amount: undefined,
    type: undefined,
    beforeBalance: undefined,
    afterBalance: undefined,
    description: undefined,
    createdAt: undefined
  }
  formRef.value?.resetFields()
}
</script>